<template>
	<mind-layout>
		<mind-form v-model="recurso" @submit="onSubmit" :rules="rules">
			<template v-slot="{form}">
					<el-row  >
						<el-col  :lg="8">
							<el-form-item  label="Movil" prop="movil">
								<el-input-number v-model.number="form.movil" :disabled="!isNew"/>
							</el-form-item>
						</el-col>
						<el-col :offset="4" :lg="12">
							<el-form-item  label="Patente" prop="patente">
										<el-input v-model="form.patente" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row  >
						<el-col  :lg="12">
							<el-form-item label="Activo">
								<el-checkbox  v-model="form.activo" />
							</el-form-item>
						</el-col>
						<el-col  :lg="12">
							<el-form-item  label="Esquema Comisión" prop="idComision">
								<el-select v-model="form.idComision" >
									<el-option
										v-for="item in listaComisiones"
										:key="item.id"
										:label="`${item.nombre} (${item.comision}%)`"
										:value="item.id">
									</el-option>
								</el-select>
								<!-- <el-checkbox  v-model="form.idComision" /> -->
							</el-form-item>
						</el-col>
					</el-row>
					<el-row  >
							<el-col  :lg="12">
								<el-form-item label="Marca" prop="marca">
									<el-input placeholder="Marca" type="text" v-model="form.marca" />
								</el-form-item>
							</el-col>
							<el-col :lg="12">
								<el-form-item  label="Modelo" prop="modelo">
									<el-input clearable placeholder="Modelo" v-model="form.modelo" />
								</el-form-item>
							</el-col>
							<el-col :lg="12">
								<el-form-item  label="Año">
									<el-input-number controls-position="right" placeholder="Año" v-model="form.año" />
								</el-form-item>
							</el-col>
							<el-col :lg="12">
								<el-form-item  label="Color">
									<el-input placeholder="Color" v-model="form.color" />
								</el-form-item>
							</el-col>
					</el-row>
					<el-row  >
							<el-col >
								<el-form-item label="Detalles">
									<el-input type="textarea" v-model="form.detalles" rows="5"/>
								</el-form-item>
							</el-col>
					</el-row>

			</template>
		</mind-form>
	</mind-layout>
</template>
<script>
import store from '@/store/moviles'
import storeComisiones from '@/store/comisiones'
import {Rest, Rules} from '@/../vendor/mind-core-web'
console.log(Rules)

export default {
	async created(){
		this.api = new Rest({
			uri: `/api/viajes/agencias/${store.idAgencia}/moviles`, 
			state: store.data,
			key: 'movil'
		})

		this.apiComisiones = new Rest({
			uri: `/api/viajes/agencias/${store.idAgencia}/comisiones`, 
			state: storeComisiones.data,
			key: 'id'})
		this.fetchComisiones()

		let id = this.$route.params.id
		if(id == 'new') {
			this.isNew = true
			this.recurso = {	}
		} else {
			this.recurso = await this.api.Fetch(id).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});				
			})
		}
	},
	computed: {
		listaComisiones() {
			return storeComisiones.data.RESOURCE_LIST
		}
	},

	methods: {
		fetchComisiones() {
			this.apiComisiones.FetchAll().catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})
		},
		async onSubmit(data) {
			let result, msg ;
			if(this.isNew) {
				await this.api.Post(data)
				.then(()=>{
					result = 'success'
					msg = 'Móvil creado correctamente'
				})
				.catch((error)=> {
					result = 'error'
					msg = error
				})
			} else {
				await this.api.Patch(data)
				.then(()=>{
					result = 'success'
					msg = 'Móvil actualizado correctamente'
				})
				.catch((error)=> {
					result = 'error'
					msg = error
				})
			}
			this.$message({
				type: result,
				showClose: result == 'error',
				message: msg
			});
		}
	},
	data() {
		return {
			isNew: false,
			recurso: {},
			api: null,
			apiComisiones: null,
			rules: {
				marca: [
					Rules.required,
					Rules.noWhitespace
				],
				modelo: [
					Rules.required
				],
				idComision: [
					Rules.required
				],
				movil: [
					Rules.required
				],
				patente: [
					Rules.required
				],
			},
		}
	}
}
</script>